#include "oware+.h"
#include "sdl_display.h"
#include "sdl_event.h"
#include "oware-ai.h"


char syntax[] = 
"Usage: oware [options] where options can be:\n"
"  -s{n}:   start with 'n' seeds in every pit\n"
"  -p:      sets first player controlled by user\n"
"  -P:      sets second player controlled by user\n"
"  -a{l}:   sets first player controlled by machine at level 'l'\n"
"  -A{l}:   sets second player controlled by machine at level 'l'\n"
"\n"
"Level for machine controlled player can be any positive number.\n"
"\n";

char description[] =
"Oware is an abstract strategic game of African orgin\n"
"See http:/en.wikipedia.org/wiki/Oware/ for description and rules\n"
"\n";

extern int start_amount;

void usage() 
{
   printf(syntax);
   printf(description);
}

int main(int argc, char* argv[])
{
    int l0, l1;
    char ch;
    move_f fp0 = sdl_human_move;
    move_f fp1 = ai_move;	
    l1 = 4;
    l0 = 4;
    start_amount = 4;
    while ((ch = getopt(argc, argv, "pPa:A:s:")) != -1)
    {
       switch (ch)
       {
          case 's':
             start_amount = atoi(optarg);
             start_amount = start_amount > 1? start_amount: 1;  
             start_amount = start_amount < 10? start_amount: 10;  
             break;
          case 'p':
             fp0 = sdl_human_move;
             break;
          case 'P':
             fp1 = sdl_human_move;
             break;
          case 'a':
             fp0 = ai_move;
             l0 = atoi(optarg);
             l0 = l0 > 0? l0: 0;  
             printf("l0:%d\n", l0);
             break;
          case 'A':
             fp1 = ai_move;
             l1 = atoi(optarg);
             l1 = l1 > 0? l1: 0;  
             printf("l1:%d\n", l1);
             break;
          case '?':
          default:
             usage();
             exit(0);
       }
    }

    if (sdl_init() == false)
    {
       exit(1);
    }
    printf("l1:%d l0:%d\n", l1, l0);
    game_control(fp0, l0, fp1, l1, sdl_display);
    sdl_wait_exit();
    return 0;
}
