#include <stdbool.h>
#include <unistd.h>
#include <assert.h>
#include <SDL.h>
#include <SDL_video.h>
#include <SDL_image.h>
#include <SDL_ttf.h>

#include "config.h"
#include "bindir.h"
#include "sdl_event.h"

extern SDL_Surface* screen;
extern SDL_Surface* bg;
extern TTF_Font* font;

typedef struct {
   int x;
   int y;
} Pos; 
typedef void (*Action)();

typedef struct {
   Pos* p;
   SDL_Surface* s;
   char* text;
   Action action;
} MenuIteam; 

typedef struct {
   int size;
   MenuIteam* iteams;
} Menu;

static Menu* currentMenu;
static Pos pos1 = {5, 5 };
static Pos pos2 = {5, 25 };
static Pos pos3 = {5, 45 };
static void hello() {printf("hello world\n");}
SDL_Surface* stdButton = NULL;

static MenuIteam iteams[] = {
   {&pos1, NULL, "One Player", hello},
   {&pos2, NULL, "Two Players", hello},
};
static Menu mainMenu = {
   sizeof(iteams)/sizeof(MenuIteam),
   iteams
};

static void drawIteam(MenuIteam* i)
{
   SDL_Rect dest;
   dest.x = i->p->x;
   dest.y = i->p->y;
   SDL_Color text_color = {200, 128, 255};
   SDL_Color bg_color   = {250, 250, 250};
   SDL_Surface *text;
   text = TTF_RenderText_Shaded(font, i->text, text_color, bg_color);
   SDL_BlitSurface(i->s, NULL, screen, &dest);
   SDL_BlitSurface(text, NULL, screen, &dest);
   SDL_FreeSurface(text);
}


static drwaMenu(Menu m)
{
   MenuIteam *i;
   for (i = m.iteams; i; i++)
   {
      drawIteam(i);
   }
}

static clickMenu(Menu* m, Pos click)
{
   MenuIteam* i;
   for (i = m->iteams; i; i++)
   {
      if (isIteamClick(i, click))
      {
         i->action();
      }
   }
}


static void
onMouseMove(SDL_Event* Event)
{
}

static void
onMouseDown(SDL_Event* Event)
{
   Pos click = {Event->motion.x, Event->motion.y};

   switch(Event->button.button)
   {
      case SDL_BUTTON_LEFT:
         break;
      case SDL_BUTTON_RIGHT:
         return;
      case SDL_BUTTON_MIDDLE:
         return;
   }
   clickMenu(currentMenu, click);
   return;
}

static void
onKeyDown(SDL_Event* Event)
{
   return;
}

void menu_init()
{
   currentMenu = &mainMenu;
   addEventHandler(SDL_MOUSEMOTION, onMouseMove);
   addEventHandler(SDL_MOUSEBUTTONDOWN, onMouseDown);
   addEventHandler(SDL_KEYDOWN, onKeyDown);
}
