/***************************************************************************
 *
 * Oware --Ancient African board game for two. Common definitions.
 *
 * *************************************************************************/
#ifndef OWARE_AI_H
#define OWARE_AI_H

#include <stdbool.h>
#include <stdio.h>
#include <string.h>

/*
 * Board of the game has 12 pits, with several stones in each, 
 * and two pits for scores.
 * pits (houses) from 0 to 5 belongs to player 0
 * pits (houses) from 6 to 11 belongs to player 1
 */
typedef struct {
       int	pits[12];
       int	scoreP0;
       int	scoreP1;
} Board;

typedef int  (*move_f) (const Board*, char, int); 
typedef void (*print_f)(const Board*); 

bool end_of_game(const Board* board);

/* Value for undo move, can be returned by move_f */
#define UNDO (65)

/*
 * Computer move function, return number of pol to play with.
 */
int ai_move(const Board* board, char player, int level);

/*
 *Function to read human player moves
 */
int human_move(const Board* board, char player, int level);

/*
 * Set 'number' of stones in every pit. Clear scores for both players  */
void reset(Board* board, int number);
/*
 * Move function, make move of selected house, if valid.
 */
int move(Board* board, char player, int house);

/*
 * Print a board
 */
void print_text(const Board* board);

/*
 * play the game. Move function fp0 level l0 against move function fp1 level l1
 */
void game_control(move_f fp0, int l0, move_f fp1, int l1, print_f print);
#endif
